;+07022017   ,   
;07052019 minimize gagdet
Enumeration
#canvasfm;0-for draw
#scrollbar_d;1- - 
#scrollbar_s;2-  
#checkgrid;4-Grid
#checkmulti;5-MultiColumns

#textofs;6-"offset" text
#spinoffs;7 - spin for offset

#textgridx;8 text grid sizeX
#spingx;9 spin grid sizeX

#textgridy;10 text grid sizeY
#spingy;11 spin grid sizey

#checkinvert;12 - Invert
#checkalign;14- Align to grid

#textoffset
#filedoffset
#buttonoffset
EndEnumeration

Structure Area
   X.i
   Y.i
   Width.i
   Height.i
EndStructure

Global Area.Area

Global xres=641
Global yres=481
Global sprpos=0
Global sprsize=1
Global *filemem
Global fsize; 
Global gridsize=8;10; 
Global zoomode.i=1;normal
Global Files$

Procedure ModalWindow()
  
  If *filemem=0
    Result = MessageRequester("Title", "1st load file!", #PB_MessageRequester_Ok)
  Else
    
  OpenWindow(1, 0, 0, 300, 200, "Save Binary file", #PB_Window_SystemMenu | #PB_Window_WindowCentered, WindowID(0))
  TextGadget(2, 0,0, 80,  20, "save from offset",#PB_Text_Right)
  StringGadget(3,0,20,80,20,"offset here..",#PB_String_Numeric)
  SetGadgetText(3,Str(GetGadgetState(1)*GetGadgetState(2)+GetGadgetState(7)))
  
  TextGadget(4, 0,20*2, 80,  20, "size of binary");,#PB_Text_Right)
  StringGadget(5,0,20*3,80,20,"0",#PB_String_Numeric)
  ButtonGadget(6,80+20,0,80,20,"Save")
  ButtonGadget(7,80+20,20,80,20,"Cancel")
  
  DisableWindow(0, #True)
  Repeat
    Select WaitWindowEvent()
      Case #PB_Event_CloseWindow
        CloseWindow(1)
        DisableWindow(0, #False)
        Break
    EndSelect
  ForEver
  EndIf
EndProcedure


 
Procedure LoadBin(filename.s)
  sss.s=filename
  dirpos=-1
  For ii= Len(sss) To 1 Step -1
    If Mid(sss,ii,1)="\"
      dirpos=ii
      ii=0
    EndIf
  Next ii
  
  If dirpos=-1
    sss=""
   Else
     sss=Mid(sss,1,dirpos)
   EndIf
  SetCurrentDirectory(sss)
              If*filemem<>0
               FreeMemory(*filemem)
             EndIf
             fsize=FileSize(filename)
             If fsize<>-1

res=ReadFile(0,filename)
If res=0
  MessageRequester("Information","Couldn't open the file!")
  End 1  
EndIf
              *filemem=AllocateMemory(fsize)
              Result = ReadData(0, *filemem, fsize)
              CloseFile(0)
              ;sprsize=1;reset b4 open
              ;SetGadgetState(#scrollbar_s,0);2-scrollbar  
              sprpos=0;begin from memory
            Else
              Debug "oops! error"
              fsize=0
            EndIf
            ;;Debug "filesize:"+Str(fsize)
      SetGadgetState(#scrollbar_d, 0);1
      SetGadgetAttribute(#scrollbar_d,#PB_ScrollBar_Maximum,fsize) ;1
      SetGadgetAttribute(#scrollbar_d,#PB_ScrollBar_Minimum,0);1
      SetGadgetAttribute(#scrollbar_d,#PB_ScrollBar_PageLength,Int(fsize/481));1
      ;Debug "page:"+Str(Int(fsize/481))
EndProcedure

Procedure drawfilemem()
  StartDrawing(CanvasOutput(#canvasfm))
  Box(0, 0, 641, 481,RGB(0,0,0))
  
   x=zoomode*Int(Area\X/zoomode)
   y=zoomode*Int(Area\Y/zoomode)
   
   w=Int( (Area\Width-Area\X)/zoomode)*zoomode
   h=Int( (Area\Height-Area\Y)/zoomode)*zoomode
   
 
   Box (x,y,w,h, RGB(127,0,255))
  
  If (w<=0) Or (h<=0)
    StatusBarText(0, 0, "Invalid Selection,w:"+Str(w)+",h:"+Str(h))
  Else
    StatusBarText(0, 0, "x:"+Str(x)+" y:"+Str(y)+" w:"+Str( Int( w/zoomode/8 ) )+" h:"+Str(Int ( h/zoomode )) )
  EndIf

  ;multi columns
  multstart=1
  multend=1
  ;
  sprsize=GetGadgetState(#scrollbar_s);2
  ;
  gsX=GetGadgetState(#spingx); 9   
  gsY=GetGadgetState(#spingy); 11   

  If GetGadgetState(#checkmulti)=#PB_Checkbox_Checked;5 if multi
    If sprsize>80; 
      mx=641*4
    Else
      mx=641
    EndIf
;    multend=Int(641/sprsize/8);dancers.bin  sprsize   
    multend=Int(mx/sprsize/8);dancers.bin  sprsize   
;    multend=Int(641*4/sprsize/8);dancers.bin  sprsize   
  EndIf
  ;
  ;----------inverse sprite--------------
  needinv=0
  If GetGadgetState(#checkinvert)=#PB_Checkbox_Checked;12
    needinv=255
  EndIf

  ;-------------------align to grid----------------------
  ymaxdraw=yres-1
    If GetGadgetState(#checkalign)=#PB_Checkbox_Checked;14
      ymaxdraw=gsy*Int((yres-1)/(gsy-1))
      ;Debug "max:"+Str(ymaxdraw)
  EndIf
  ;
 countr=GetGadgetState(#scrollbar_d)*sprsize+GetGadgetState(#spinoffs);1*sprsize+7  * + displacement
 ;------------------------------------- ?   
 disp1=countr;   
 
 ;For mu=multstart To multend; Step zoomode
 mu=multstart
 ;To multend; Step zoomode
 While mu<=multend
   ;For yy=0 To ymaxdraw;yres-1
   yy=0
   While yy<=ymaxdraw
   For s=1 To sprsize
     If (*filemem<>0)
       If (countr)<fsize
         bb=PeekB(*filemem+countr)!needinv
;          If needinv=1
;            bb=255-bb
;          EndIf
       Else
         bb=0
       EndIf
     Else
       bb=yy
     EndIf
     countr=countr+1
      cc=128
      For xx=0 To 7
        If bb&cc;=cc
          colr=RGB(255,255,255)
         Else
          colr=RGB(0,0,0)
        EndIf
        ;      
       If (countr)>fsize
         colr=RGB(0,0,255)
       EndIf
       ;Plot((mu-1)*sprsize*8+1+xx+(s-1)*8,yy,colr)
       w=zoomode
       h=zoomode
       If zoomode=8
         w=w-1
         h=h-1
       EndIf
;       If colr
         Box((mu-1)*sprsize*8+xx*zoomode+(s-1)*8*zoomode,yy,w,h,colr)
;       EndIf
        cc=cc>>1
      Next xx
    Next s
    
    yy=yy+zoomode
  Wend;Next yy
  
  mu=mu+zoomode
 Wend;Next mu
 ;drawgrid after sprite
   wt.s="SpriteGrabber 0.10.0, sprsize:"+Str(sprsize)
   
;!---------------------draw grid--------------------------------    
   If GetGadgetState(#checkgrid)=#PB_Checkbox_Checked;4 if grid
     wt.s=wt+", grid:"+Str(gsx)+"x"+Str(gsy)

    x=gsx
    Repeat
       If x%(gsX*gsx)
        LineXY(x,0,x,481,RGB(255,0,0))
       Else
        LineXY(x,0,x,481,RGB(0,255,0))
       EndIf
       x=x+gsX
    Until x>641

    y=gsy
 ;   direction.a=0
 Repeat
   If y%(gsY*gsY)
     LineXY(0,y,641,y,RGB(255,0,0))
   Else
     LineXY(0,y,641,y,RGB(0,255,0))
   EndIf
      y=y+gsY
    Until y>481

  EndIf
  
  
  
  SetGadgetText(#filedoffset,Str(disp1))
  wt=wt+" disp:"+Str(disp1)
  wt=wt+" zoom:"+Str(zoomode)
  SetWindowTitle(0, wt);if "Grid" checkbox
 
    StopDrawing()
  EndProcedure

If OpenWindow(0, 0, 0, 660, 610, "SpriteGrabber 0.10.0", #PB_Window_SystemMenu | #PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
    If CreateMenu(0, WindowID(0))
      MenuTitle("Project")
        MenuItem(1, "Open..")
        MenuItem(2, "Save image..")
        MenuItem(3, "Save binary..")
        MenuBar(); here the separator bar will be inserted
        MenuItem(4, "Quit")
        
        ;next subitems
        CloseSubMenu()
        MenuItem(5, "x1")
        MenuItem(6, "x2")
        MenuItem(7, "x8")

        MenuItem(8, "Save selected")
        DisableMenuItem(0, 8, 1)
      EndIf
      filemem=0

      CanvasGadget(0, 0, 0, 641, 481)
      

      ScrollBarGadget(#scrollbar_s,0,500, 640, 17, 1, 256+15, 16) ; 2 horizontal for sprsize 0..64
      BindGadgetEvent(#scrollbar_s,@drawfilemem())
;-------------  , displacement-------------------------
      ScrollBarGadget(#scrollbar_d, 641, 0,  14, 470 ,0, 481, 32, #PB_ScrollBar_Vertical);1 vertical for deltaofs 0..481?
      BindGadgetEvent(#scrollbar_d,@drawfilemem())
;---------------extended options-------------------------------
CheckBoxGadget(#checkgrid,0,520,20*4,20,"Grid");4
;
CheckBoxGadget(#checkinvert,0,520+20,20*4,20,"Invert");12
;
CheckBoxGadget(#checkmulti,20*4,520,20*4,20,"MultiColumns") ; 5
;
CheckBoxGadget(#checkalign,20*4,520+20,20*4,20,"Align to grid") ; 14
;-------------edit text----------------------------------------
    TextGadget(#textofs, 20*4*2,520, 80,  20, "offset",#PB_Text_Right);6
    SpinGadget(#spinoffs,20*4*2+80,520,80,20,0,1); 7      Max;--  spritesize
;-------------grid size X text---------------------------------
    TextGadget(#textgridx, 20*4*2+80*2,520, 80,  20, "grid sizeX",#PB_Text_Right);8
    SpinGadget(#spingx, 20*4*2+80*3, 520, 80, 20, 1, 25,#PB_Spin_Numeric);9
    SetGadgetState (#spingx, gridsize);9
    SetGadgetText(#spingx, Str(gridsize)); 9 set initial value

;-------------grid size Y text---------------------------------
    TextGadget(#textgridy, 20*4*2+80*2,520+20, 80,  20, "grid sizeY",#PB_Text_Right);10
    SpinGadget(#spingy, 20*4*2+80*3, 520+20, 80, 20, 1, 25,#PB_Spin_Numeric);11
    SetGadgetState (#spingy, gridsize);11
    SetGadgetText(#spingy, Str(gridsize)); 11 set initial value
    
;-------------- offset field
TextGadget(#textoffset, 20*4*2+10,540, 70,  20, "disp",#PB_Text_Right)
StringGadget(#filedoffset, 20*4*2+80, 540, 80, 20, "1234567", #PB_String_Numeric)
ButtonGadget(#buttonoffset,20*4*2+80*2,540,20,20,">")
    
;-enable drag'm'drop
EnableWindowDrop(0,#PB_Drop_Files,#PB_Drag_Copy)
;---------?statusbar
CreateStatusBar(0, WindowID(0))
AddStatusBarField(#PB_Ignore)
StatusBarText(0, 0, "selection:")

pdn.s=ProgramParameter(0)
;OpenFile(0,pdn)
fss=FileSize(pdn)
;CloseFile(0)
If fss>0
  files$=pdn
  LoadBin(pdn)
  LoadBin(pdn)
EndIf

drawfilemem(); show

Noexit=0
;-----------------------------main event loop--------------------------------
Repeat
  If GetAsyncKeyState_(#VK_ESCAPE)=-32767
    Noexit=1
  EndIf
  
  If GetAsyncKeyState_(#VK_LEFT)=-32767
    vv=GetGadgetState(#scrollbar_s);2
    If vv>0
      SetGadgetState(#scrollbar_s,vv-1);2
      SetGadgetAttribute(#spinoffs,#PB_Spin_Minimum,-vv+1);7
      SetGadgetAttribute(#spinoffs,#PB_Spin_Maximum,vv-1);7
      SetGadgetText(#spinoffs,"0");7
      drawfilemem()
    EndIf
  EndIf
  
  If GetAsyncKeyState_(#VK_RIGHT)=-32767
    vv=GetGadgetState(#scrollbar_s);2
    If vv<256+16
      SetGadgetState(#scrollbar_s,vv+1);2
      SetGadgetAttribute(#spinoffs,#PB_Spin_Minimum,-vv-1);7
      SetGadgetAttribute(#spinoffs,#PB_Spin_Maximum,vv+1);7
      SetGadgetText(#spinoffs,"0");7
      drawfilemem()
    EndIf
  EndIf
  
  If GetAsyncKeyState_(#VK_UP)=-32767
    vv=GetGadgetState(#scrollbar_d);1
    SetGadgetState(#scrollbar_d,vv+1);1
    drawfilemem()
  EndIf

  If GetAsyncKeyState_(#VK_DOWN)=-32767
    vv=GetGadgetState(#scrollbar_d);1
    If vv>0
    SetGadgetState(#scrollbar_d,vv-1);1
    drawfilemem()
    EndIf
  EndIf
  
    Event = WaitWindowEvent()
    ;Noexit=0
       Select Event
         Case #PB_Event_CloseWindow
           Noexit=1

         Case #PB_Event_WindowDrop
           Files$ = EventDropFiles()
           Files$ = StringField(Files$, 1, Chr(10))
           LoadBin(Files$)
           drawfilemem()
       Case #PB_Event_Gadget
         Select EventGadget()
;!-----canvas handle----------------------             
Case #buttonoffset:
             ddd=Val( GetGadgetText(#filedoffset) )
             SetGadgetState(#scrollbar_d,Int(ddd/sprsize))
;             SetGadgetState(#scrollbar_d,ddd)
             drawfilemem()

           Case #canvasfm:
               Select EventType()
                  Case #PB_EventType_LeftButtonDown
                     Area\X = GetGadgetAttribute(#canvasfm, #PB_Canvas_MouseX);-GadgetX(#canvasfm)
                     Area\Y = GetGadgetAttribute(#canvasfm, #PB_Canvas_MouseY);-GadgetY(#canvasfm)
                     Area\Width = 0
                     Area\Height = 0
                     DisableMenuItem(0, 8, 1)
                     drawfilemem()
                  Case #PB_EventType_MouseMove, #PB_EventType_LeftButtonUp
                     If GetGadgetAttribute(#canvasfm, #PB_Canvas_Buttons) & #PB_Canvas_LeftButton
                        Area\Width = GetGadgetAttribute(#canvasfm, #PB_Canvas_MouseX);-Area\X
                        Area\Height = GetGadgetAttribute(#canvasfm, #PB_Canvas_MouseY);-Area\Y
                        
                        ww=Int( (Area\Width-Area\X)/zoomode)

                        If ww<=sprsize*8
                        drawfilemem()
                        w=Area\Width-Area\X
                        h=Area\Height-Area\Y
                        If (w<=0) Or (h<=0)
                          Else
                            DisableMenuItem(0, 8, 0)
                        EndIf
                       EndIf

                      EndIf
                  Case #PB_EventType_RightClick;
                    sprs=GetGadgetState(2);2
                    dis=8*Int(GetGadgetAttribute(#canvasfm, #PB_Canvas_MouseX)/8);0
                    dis=Int(dis*60/sprs)+GetGadgetAttribute(#canvasfm, #PB_Canvas_MouseY)+GetGadgetState(#scrollbar_d); 0,1
                    SetGadgetState(#scrollbar_d,dis);1
                    drawfilemem()
               EndSelect

           Case #checkgrid :drawfilemem();4 enable grid
           Case #checkmulti :drawfilemem();5 enable multicolumn
           Case #checkinvert :drawfilemem();12 inverse
           Case #checkalign :drawfilemem();14
           Case #spingy :;11 gridsizeY
             If EventType()=#PB_EventType_Change
               tempgrid=Val(GetGadgetText(#spingy));11
              Else
                tempgrid=GetGadgetState(#spingy);11
              EndIf
             If tempgrid=0
               tempgrid=1
             EndIf
             If tempgrid>25;16;------------  
               tempgrid=25;16
             EndIf
               SetGadgetState(#spingy, tempgrid);11
               SetGadgetText(#spingy, Str(tempgrid));11
               SendMessage_(GadgetID(#spingy),#WM_KEYDOWN,#VK_END,0);11
               drawfilemem()
           Case #spingx:;9 :;gridsizeX
             If EventType()=#PB_EventType_Change
               tempgrid=Val(GetGadgetText(#spingx));9
              Else
                tempgrid=GetGadgetState(#spingx);9
              EndIf
             If tempgrid=0
               tempgrid=1
             EndIf
             If tempgrid>25;16;------------  
               tempgrid=25;16
             EndIf
               SetGadgetState(#spingx, tempgrid);9
               SetGadgetText(#spingx, Str(tempgrid));9
               SendMessage_(GadgetID(#spingx),#WM_KEYDOWN,#VK_END,0);9
               drawfilemem()
;-----------------------------------------------------------             
Case #spinoffs:;7:;displacement
   bound=GetGadgetState(#scrollbar_s);2      
             If EventType()=#PB_EventType_Change
               tempval=Val(GetGadgetText(#spinoffs));7
              Else
                tempval=GetGadgetState(#spinoffs);7
              EndIf
             If tempval>bound;---------------   
               tempval=bound
               Debug bound
             EndIf
               SetGadgetState(#spinoffs, tempval);7
               SetGadgetText(#spinoffs, Str(tempval));7
               SendMessage_(GadgetID(#spinoffs),#WM_KEYDOWN,#VK_END,0);7
               drawfilemem()

;-----------------------------------------------------------             
           Case #scrollbar_d :;1  
             drawfilemem()
;-----------------------------------------------------------             
Case #scrollbar_s :;2
 sprdisp=GetGadgetState(#scrollbar_s);2
 SetGadgetAttribute(#spinoffs,#PB_Spin_Minimum,-sprdisp);7
 SetGadgetAttribute(#spinoffs,#PB_Spin_Maximum,sprdisp);7
 SetGadgetText(#spinoffs,"0");7
  
  drawfilemem()
         EndSelect
;-----------------------------------------------------------       
       Case #PB_Event_Menu
         Select EventMenu()
;--------------------save selected area as binary,4-grid
           Case 8
             grs=GetGadgetState(#checkgrid)
             SetGadgetState(#checkgrid,0)
             drawfilemem()
             ;              Debug "file:"+Files$
             filen.i=0
             find_new_file:
             fsb.s=files$+"."+RSet(Str(filen),3,"0")
             If FileSize(fsb)>0
  filen+1:Goto find_new_file;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
EndIf

  w=Int( (Area\Width-Area\X)/zoomode)
  h=Int( (Area\Height-Area\Y)/zoomode)

;   w=Int(Area\Width/zoomode)
;   h=Int(Area\Height/zoomode)
; ; ; ;   If (w<=0) Or (h<=0)
; ; ; ;     StatusBarText(0, 0, "Can't Save")
; ; ; ;   Else
;StatusBarText(0, 0, "x:"+Str(Int(Area\X/zoomode/8))+" y:"+Str(Int(Area\Y/zoomode))+" w:"+Str(w)+" h:"+Str(h))
; ; ; ;   EndIf
StartDrawing(CanvasOutput(#canvasfm))
CreateFile(1,fsb)


wh=RGB(255,255,255)
For y=0 To h;*zoomode
  bb.a=128
  cccc.a=0
  For x=0 To w;*8
    gc=0
    If Int( Area\Y/zoomode )+zoomode*y <481; 
      x0=zoomode*Int(Area\X/zoomode)+x*zoomode;Int( Area\X/zoomode)+x*zoomode
      y0=zoomode*Int(Area\Y/zoomode)+y*zoomode;zoomode*Int( Area\Y/zoomode )+y*zoomode
gc=Point( x0,y0)
;Plot (x0,y0,RGB (255,0,0) )

     EndIf

    If gc = wh
      cccc=cccc +bb
    EndIf
    bb=bb>>1
    If bb=0
      WriteAsciiCharacter(1,cccc)
      bb.a=128
      cccc.a=0
    EndIf

;     x+zoomode
; Wend;
 Next x
Next y
StopDrawing()
CloseFile(1)
SetGadgetState(#checkgrid,grs)
drawfilemem()

           Case 1 
             Files$ = OpenFileRequester("Please choose file to load", "", "Any(*.*)", 0)
             If Files$<>""
               LoadBin(Files$)
               drawfilemem()
             EndIf
           Case 5;zoomx1,6-x2,7-x4
             zoomode=1
             drawfilemem()
           Case 6
             zoomode=2
             drawfilemem()
           Case 7
             zoomode=8
             drawfilemem()
           Case 3
             If EventGadget() = 3
                 If *filemem=0
                   Result = MessageRequester("Title", "1st load file!", #PB_MessageRequester_Ok)
  Else
;ModalWindow()
Input$ = InputRequester("Title", "size of the file", "0000")
filelen=Val(Input$)
If filelen>0;right input
  def.s=GetCurrentDirectory()+"\"+GetFilePart(files$)
  saveFile$ = SaveFileRequester("Save binary file", def, "Binary|*.bin|All Files|*.*", 0)
If saveFile$
   index=SelectedFilePattern()
;--------add file extension   
If index=0
   saveFile$=saveFile$+".bin"
EndIf
;--------save binary
If (FileSize(saveFile$) = -1 Or MessageRequester("save binary", "Overwrite this file? " + saveFile$, #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes)
  CreateFile(2,savefile$)
  disp2=GetGadgetState(#scrollbar_d)*GetGadgetState(#scrollbar_s)+GetGadgetState(#spinoffs);1*2+7
    ;----------inverse sprite--------------
  needinv=0
  If GetGadgetState(#checkinvert)=#PB_Checkbox_Checked;12 if invert sprite
    needinv=1
  EndIf
  For ii=1 To filelen
    bb=PeekB(*filemem+ii-1+disp2);  !
    If needinv=1
       bb=255-bb
     EndIf
     WriteByte(2,bb)
  Next ii
  CloseFile(2)
EndIf

EndIf

EndIf
EndIf

EndIf

;----------------------save image
    Case 2
  def.s=GetCurrentDirectory()+"\"+GetFilePart(files$)
            FileS$ = SaveFileRequester("Save PNG Image AS...", def, "PNG Images|*.png|All Files|*.*", 0)
            If FileS$
               index=SelectedFilePattern()
            If index=0
                FileS$=FileS$+".png"
            EndIf

          If FileS$ And (FileSize(FileS$) = -1 Or MessageRequester("CanvasGadget", "Overwrite this file? " + FileS$, #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes)
            If CreateImage(1, 641, 481, 24) And StartDrawing(ImageOutput(1))
              DrawImage(GetGadgetAttribute(0, #PB_Canvas_Image), 0, 0);????
              StopDrawing()
              
              UsePNGImageDecoder()
              UsePNGImageEncoder()
             
              If SaveImage(1, FileS$, #PB_ImagePlugin_PNG) = 0
                MessageRequester("CanvasGadget", "Cannot save image: " + File$)
              EndIf
              
              FreeImage(1)
            EndIf
           EndIf
          EndIf
;-------------------------------------------------------
           Case 4 : Noexit=1;quit selected
         EndSelect
     
     EndSelect
;----------------------little check
   ;Until (Event = #PB_Event_CloseWindow) Or (Noexit=1)
   Until Noexit=1
   If*filemem<>0
      FreeMemory(*filemem)
   EndIf
  EndIf

; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 1
; Folding = 9
; EnableXP
; UseIcon = production.ico
; Executable = bingrab.exe